#version 100

// This came from some tutorial, mentioning some drivers required this to function
//   properly but did not delve into why. 
precision highp float;

varying vec3 fsNormal;
varying vec4 fsColor;
varying vec2 fsTextureUV;

// sAlbedoTexture is a 2D texture sampler for diffuse texture.
uniform sampler2D sAlbedoTexture;
uniform vec4 ambientLightColor;// = vec4(1.0, 1.0, 1.0, 1.0);
uniform vec4 sunLightColor;// = vec4(1.0, 1.0, 1.0, 1.0);
uniform vec4 sunLightDirection;// = vec4(-0.447766751, 0.373415232, 0.812444329, 0.422158539);  //Expected to be a unit vector and in world space already.
uniform vec4 uMaterialColor;// = vec4(1.0, 1.0, 1.0, 1.0);

void main(void)
{
	vec4 texturedfsColor = fsColor * uMaterialColor * texture2D(sAlbedoTexture, fsTextureUV);

	float nDotL = clamp(dot(fsNormal, vec3(sunLightDirection)), 0.0, 1.0);
	
	vec3 diffuseLighting = (nDotL * vec3(texturedfsColor) * vec3(sunLightColor));
	vec3 ambientLighting = vec3(ambientLightColor) * vec3(texturedfsColor);
	vec3 finalColor = ambientLighting + diffuseLighting;

	float gamma 2.2;
	gl_FragColor = vec4(pow(finalColor, vec3(1.0 / gamma, 1.0 / gamma, 1.0 / gamma)), texturedfsColor.a);

	if (gl_FragColor.a < 0.25)
	{
		discard;
	}	
}
